package bc_enc;

use bc_handleproto;

use strict;

# Subspace encryption

sub initialize {
  use bigint;
  my $seed = $_[0];
  my ($tempSeed, $oldSeed, $i);
  our @table;
  $tempSeed = $seed;
  
  # use Math::BigInt;
  # my $seed = Math::BigInt->new($_[0]);
  # my ($tempSeed, $oldSeed);
  # $tempSeed = Math::BigInt->new("$seed");

  for ($i = 0; $i < (520 / 2); $i++) {
    $oldSeed = $tempSeed;

    $tempSeed = (($oldSeed * 0x834E0B5F) >> 48);
    $tempSeed = (($tempSeed + ($tempSeed >> 31)));
    $tempSeed = (((($oldSeed % 0x1F31D) * 16807) - ($tempSeed * 2836) + 123));
    if ($tempSeed > 0x7fffffff ) {
      $tempSeed = (($tempSeed + 0x7fffffff));
    }
    push(@table, ence_short(short($tempSeed)));
  }
}
sub initializeout {
  use bigint;
  my $seed = $_[0];
  my ($tempSeed, $oldSeed, $i);
  our @table;
  $tempSeed = $seed;
  
  # use Math::BigInt;
  # my $seed = Math::BigInt->new($_[0]);
  # my ($tempSeed, $oldSeed);
  # $tempSeed = Math::BigInt->new("$seed");

  for ($i = 0; $i < (520 / 2); $i++) {
    $oldSeed = $tempSeed;

    $tempSeed = (($oldSeed * 0x834E0B5F) >> 48) & 0xffffffff;
    $tempSeed = (($tempSeed + ($tempSeed >> 31)) & 0xffffffff);
    $tempSeed = (((($oldSeed % 0x1F31D) * 16807) - ($tempSeed * 2836) + 123) & 0xffffffff);
    if ($tempSeed > 0x7fffffff ) {
      $tempSeed = (($tempSeed + 0x7fffffff) & 0xffffffff);
    }
    push(@table, ence_short(short($tempSeed & 0xffff)));
  }
}

sub ssencrypt {
  my ($size, @packet) = @_;
  my ($tempKey, $tempInt, $count, @output, @soutput, $index, $i);
  our @table;
  
  if (@packet[0] == 0x00) {
    $index = 2;
  } else {
    $index = 1;
  }

  $tempKey = $bc_global::serverKey;
  #$count = int( scalar(@packet) + (4 - scalar(@packet) % 4) );
  #$count = scalar(@packet);
  $count = $#packet - $index + 1;

  @output = @packet[$index .. $#packet];
  for ($i = 0; $i < $count; $i += 4) {
    $tempInt = dece_int(@output[$i .. ($i+3)]) ^ dece_int(@table[$i .. $i+3]) ^ $tempKey;
    $tempKey = $tempInt;
    #@output[$i .. ($i+3)] = ence_int(int($tempInt & 0xffffffff));
    @output[$i .. ($i+3)] = ence_int(int($tempInt));
  }

  unshift(@output, @packet[0 .. $index-1]);
  @soutput = @output[0 .. $size-1];
  return @soutput;
}

sub ssdecrypt {
  my ($size, @packet) = @_;
  my ($tempKey, $tempInt, $count, @output, @soutput, $index, $i);
  our @table;
  
  if (@packet[0] == 0x00) {
    $index = 2;
  } else {
    $index = 1;
  }

  $tempKey = $bc_global::serverKey;
  #$count = int( scalar(@packet) + (4 - scalar(@packet)%4) );
  #$count = scalar(@packet);
  $count = $#packet - $index + 1;

  @output = @packet[$index .. $#packet];
  for ($i = 0; $i < $count; $i += 4) {
    $tempInt = dece_int(@table[$i .. $i+3]) ^ $tempKey ^ dece_int(@output[$i .. ($i+3)]);
    $tempKey = dece_int(@output[$i .. ($i+3)]);
    #@output[$i .. ($i+3)] = ence_int(int($tempInt & 0xffffffff));
    @output[$i .. ($i+3)] = ence_int(int($tempInt));
  }

  unshift(@output, @packet[0 .. $index-1]);
  @soutput = @output[0 .. $size-1];
  return @output;
}

# Packet encryption

# Only send decimals to encrypt
sub encrypt {
  my @data = @_;
  my (@ssencrypted, $encrypted, @pre);
  if ($bc_global::initEncryption == 1) {
    @ssencrypted = ssencrypt(scalar(@data), @data);
    $encrypted = pack("C*", @ssencrypted);
    return $encrypted;
  } else {
    $encrypted = pack("C*", @data);
    return $encrypted;
  }
  #$encrypted = pack("C*", @data);
  #return $encrypted;
}

sub noss_encrypt {
  my @data = @_;
  my (@ssencrypted, $encrypted);
  $encrypted = pack("C*", @data);
  return $encrypted;
}

sub decrypt {
  my $data = $_[0];
  my (@ssdecrypted, @decrypted, @pre);
  
  if ($bc_global::initEncryption == 1) {
    @decrypted = unpack("C*", $data);
    @ssdecrypted = ssdecrypt(scalar(@decrypted), @decrypted);
    return @ssdecrypted;
  } else {
    @decrypted = unpack("C*", $data);
    return @decrypted;
  }
  #@decrypted = unpack("C*", $data);
  #return @decrypted;
}

sub todec {
  my @numbers = @_;
  my (@dec, $i);
  $i = 0;
  foreach (@numbers) {
    $dec[$i] = hex($_);
    $i++;
  }
  return @dec;
}

sub tohex {
  my @numbers = @_;
  my (@hexn, $i);
  $i = 0;
  foreach (@numbers) {
    $hexn[$i] = sprintf("%02x", $_);
    $i++;
  }
  return @hexn;
}

sub to1hex {
  my $number = $_[0];
  my $hexn;
  $hexn = sprintf("%02x", $number);
  return $hexn;
}

sub short {
  my $theShort = $_[0];
  my $rShort;
  $rShort = sprintf("%hd", $theShort);
  return $rShort;
}

sub enc_byte {
  my $theByte = $_[0];
  $theByte = (($theByte) & 0xff);
  return $theByte;
}

sub enc_sbyte {
  my $theByte = $_[0];
  $theByte = pack("c", $theByte);
  return $theByte;
}

sub ence_short {
  my $theShort = $_[0];
  my @lShort;
  $theShort = short($theShort);
  $lShort[0] = (($theShort) & 0xff);
  $lShort[1] = (($theShort>>8) & 0xff);
  return @lShort;
}

sub ence_int {
  my $theInt = $_[0];
  my @lInt; 
  $theInt = int($theInt);
  $lInt[0] = (($theInt) & 0xff);
  $lInt[1] = (($theInt>>8) & 0xff);
  $lInt[2] = (($theInt>>16) & 0xff);
  $lInt[3] = (($theInt>>24) & 0xff);
  return @lInt;
}

sub ence_nint {
  my $theInt = $_[0];
  my @lInt;
  $theInt = int($theInt);
  $lInt[0] = unpack("c", pack("c", (($theInt) & 0xff)));
  $lInt[1] = unpack("c", pack("c", (($theInt>>8) & 0xff)));
  $lInt[2] = unpack("c", pack("c", (($theInt>>16) & 0xff)));
  $lInt[3] = unpack("c", pack("c", (($theInt>>24) & 0xff)));
  return @lInt;
}

sub pad_str {
  my $str = $_[0];
  my $strLen = $_[1];
  my ($pstr, @lStr);
  $pstr = sprintf("%-*s", $strLen, $str);
  $pstr =~ s/[\s*]/0/g;
  @lStr = unpack("a" x $strLen, $pstr);
  return @lStr;
}

sub pad_array {
  my $size = $_[0];
  my (@a, $i);
  for ($i = 0; $i < $size; $i++) {
    $a[$i] = 0;
  }
  return @a;
}

sub dece_short {
  my @data = @_;
  my $dl;
  $dl = ( (($data[1] & 0xff)<<8) | (($data[0] & 0xff)) );
  return $dl;
}

sub dece_int {
  my @data = @_;
  my $dl;
  $dl = ( (($data[3] & 0xff)<<24) | (($data[2] & 0xff)<<16) | (($data[1] & 0xff)<<8) | (($data[0] & 0xff)) );
  return $dl;
}

sub dece_nint {
  my @data = @_;
  my $dl;
  $dl = unpack("l", pack("l", ( (($data[3] & 0xff)<<24) | (($data[2] & 0xff)<<16) | (($data[1] & 0xff)<<8) | (($data[0] & 0xff)) )));;
  return $dl;
}

# Signal EOF
1;
